--
-- MUTANTS : a generic genetic algorithm toolkit for Ada 95
--
-- Binary bit vector evaluation component test
--
-- Author  Matthew Caryl
-- Created 14.1.97
--

with Mutants.Core.Evaluation.Binary_Bit_Vector;
with Mutants.Core.Representation.Bit_Vector;
with Mutants.Core.Representation.Bit;
with Mutants.Core.Representation;
with Ada.Text_IO.Float_IO;
use Mutants.Core.Evaluation.Binary_Bit_Vector;
use Mutants.Core.Representation.Bit_Vector;
use Mutants.Core.Representation.Bit;
use Mutants.Core.Representation;
use Ada.Text_IO;

procedure EvaluationTest is

	package Float_IO is new Ada.Text_IO.Float_IO(Float);

	ev : Binary_Bit_Vector_Evaluation;
	bv : Vector_Representation_Access;
	b : Bit_Representation_Access;
	v : Integer;
begin
	bv := new Vector_Representation(8);
	for i in 0..255 loop
		v := i;
		for j in 1..8 loop
			Get(bv, j, b);
			Set(b, (v mod 2) = 1);
			v := v / 2;
		end loop;
		Float_IO.Put(Evaluate(ev, Representation_Access(bv)));
		New_Line;
	end loop;
end EvaluationTest;
