--
-- MUTANTS : a generic genetic algorithm toolkit for Ada 95
--
-- Unity fitness component test
--
-- Author  Matthew Caryl
-- Created 19.12.96
--

with Mutants.Core.Individual;
with Mutants.Core.Representation.Bit;
with Mutants.Core.Representation;
with Mutants.Core.Population;
with Mutants.Core.Fitness.Unity;
with Ada.Text_IO.Enumeration_IO;
with Ada.Text_IO.Float_IO;
use Mutants.Core.Individual;
use Mutants.Core.Representation.Bit;
use Mutants.Core.Representation;
use Mutants.Core.Population;
use Mutants.Core.Fitness.Unity;
use Ada.Text_IO;

procedure FitnessTest is

	package Boolean_IO is new Ada.Text_IO.Enumeration_IO(Boolean);
	package Float_IO is new Ada.Text_IO.Float_IO(Float);

	procedure Test(Fit : Fitness'Class; Pop : Population) is
		fi : FitnessIterator'Class := Iterator(Fit);
		v : Float;
		m : boolean;
		i : Individual_Access;
	begin
		Next(fi, m, i, v);
		while m loop
			Boolean_IO.Put(Get(Bit_Representation_Access(Mutants.Core.Individual.Representation(i))));
			New_Line;
			Float_IO.Put(v);
			New_Line;
			Next(fi, m, i, v);
		end loop;
	end Test;

	b : Bit_Representation_Access;
	i : Individual_Access;
	p : aliased Population;
	f : Unity_Fitness;
begin
	for n in 1..10 loop
		b := new Bit_Representation;
		if (n mod 2 = 0) then
			Set(b, true);
		else
			Set(b, false);
		end if;
		i := new Individual(Representation_Access(b));
		Evaluation(i, Float(n));
		Add(p, i);
	end loop;
	Attach(f, p'Unchecked_Access);
	Test(f, p);
end FitnessTest;
