--
-- MUTANTS : a generic genetic algorithm toolkit for Ada 95
--
-- Core Toolkit - One point vector crossover reproduction component
--
-- Author  Matthew Caryl
-- Created 22.1.97
--
-- Unfinished - need to include history varient

with Mutants.Core.Selector;
with Mutants.Core.Population;
with Mutants.Core.Individual;
with Mutants.Core.Representation.Vector;
with Mutants.Core.Random;
with Ada.Unchecked_Deallocation;
use Mutants.Core.Selector;
use Mutants.Core.Population;
use Mutants.Core.Individual;
use Mutants.Core.Random;

package body Mutants.Core.Creator.Onepoint_Vector_Crossover_Reproduction is

	use Vector_Package;
	procedure Free is new Ada.Unchecked_Deallocation(Vector_Representation, Vector_Representation_Access);

	use Vector_Package;
	procedure Create(Creator : in out Onepoint_Vector_Crossover_Reproduction; Pop : in out Mutants.Core.Population.Population; Size : in Natural) is
		i : Individual_Access;
		r : Representation_Access;
		e : Element_Type_Access;
		v, p1, p2 : Vector_Representation_Access;
		p : Natural;
		s : Natural;
	begin
		-- make require number of individuals
		for j in 1..Size loop
			-- select two parents
			Get(Creator.Selector.all, i);
			p1 := Vector_Representation_Access(Mutants.Core.Individual.Representation(i));
			Get(Creator.Selector.all, i);
			p2 := Vector_Representation_Access(Mutants.Core.Individual.Representation(i));
			-- choose split point
			s := Vector_Package.Size(p1);
			p := Value(Creator.Chance, s) + 1;
			-- make new representation
			v := new Vector_Representation(s);
			for k in 1..p loop
				Get(p1, k, e);
				Set(v, k, e.all);
			end loop;
			for k in p..s loop
				Get(p2, k, e);
				Set(v, k, e.all);
			end loop;
			-- make new individual
			i := new Mutants.Core.Individual.Individual(Representation_Access(v));
			Add(Pop, i);
			Free(v);
		end loop;
	end Create;

	procedure Selector(Creator : in out Onepoint_Vector_Crossover_Reproduction; Sel : Selector_Access; Required : out Boolean) is
	begin	
		Creator.Selector := Sel;
		Required := true;
	end Selector;
	
	function Parents(Creator : in Onepoint_Vector_Crossover_Reproduction) return Natural is
	begin
		return 2;
	end Parents;
	
	use Vector_Package;
	procedure Breed(Creator : in out Onepoint_Vector_Crossover_Reproduction; Reps_In : in Representation_Access_Array; Rep_Out : out Representation_Access; Success : out Boolean) is
		v : Vector_Representation_Access;
		s : Natural;
		p : Natural;
		e : Element_Type_Access;
	begin
		s := Size(Vector_Representation_Access(Reps_In(1)));
		v := new Vector_Representation(s);
		p := Value(Creator.Chance, s) + 1;
		for i in 1..p loop
			Get(Vector_Representation_Access(Reps_In(1)), i, e);
			Set(v, i, e.all);
		end loop;
		for i in 1..p loop
			Get(Vector_Representation_Access(Reps_In(2)), i, e);
			Set(v, i, e.all);
		end loop;
		Rep_Out := Representation_Access(v);
		Success := true;
	end Breed;

end Mutants.Core.Creator.Onepoint_Vector_Crossover_Reproduction;
