--
-- MUTANTS : a generic genetic algorithm toolkit for Ada 95
--
-- Core Toolkit - Vector random initialise component
--
-- Author  Matthew Caryl
-- Created 16.1.97
--
-- Unfinished - need to include history varient

with Mutants.Core.Selector;
with Mutants.Core.Population;
with Ada.Unchecked_Deallocation;
use Mutants.Core.Individual;
use Mutants.Core.Population;

package body Mutants.Core.Creator.Vector_Initialise is

	use Vector_Package;
	procedure Free is new Ada.Unchecked_Deallocation(Vector_Representation, Vector_Representation_Access);

	use Vector_Package;
	procedure Create(Creator : in out Vector_Initialise; Pop : in out Mutants.Core.Population.Population; Size : in Natural) is
		i : Individual_Access;
		v : Vector_Representation_Access;
		e : Element_Type_Access;
		rs : Representation_Access_Array(1..1);
		r : Representation_Access;
		success : Boolean;
	begin
		v := new Vector_Representation(Creator.Maximum);
		-- create population
		for j in 1..Size loop
			-- create each element
			for k in 1..Creator.Maximum loop
				-- breed element
				Breed(Creator.Initer.all, rs, r, success);
				-- set element into vector
				Set(v, k, Element_Type_Access(r).all);
			end loop;
			-- create individual
			i := new Mutants.Core.Individual.Individual(Representation_Access(v));
			-- add to population
			Add(Pop, i);
		end loop;
		Free(v);
	end Create;

	procedure Selector(Creator : in out Vector_Initialise; Sel : Selector_Access; Required : out Boolean) is
	begin
		Selector(Creator.Initer.all, Sel, Required);
	end Selector;

	function Parents(Creator : in Vector_Initialise) return Natural is
	begin
		return Parents(Creator.Initer.all);
	end Parents;
	
	use Vector_Package;
        procedure Breed(Creator : in out Vector_Initialise; Reps_In : in Representation_Access_Array; Rep_Out : out Representation_Access; Success : out Boolean) is
		s : Integer := Parents(Creator);
		b : Representation_Access;
		r : Representation_Access_Array(1..s);
		bv : Vector_Representation_Access;
		e : Element_Type_Access;
		v : Vector_Representation_Access;
	begin
		bv := new Vector_Representation(Creator.Maximum);
		for k in 1..Creator.Maximum loop	
			for i in 1..s loop
				v := Vector_Representation_Access(Reps_In(i));
				Get(v, k, e);
				r(i) := Representation_Access(e);
			end loop;
			Breed(Creator.Initer.all, r, b, Success);
			Set(bv, k, Element_Type(b.all));
		end loop;
		Rep_Out := Representation_Access(bv);
	end Breed;
	
end Mutants.Core.Creator.Vector_Initialise;
