--
-- MUTANTS : A generic genetic algorithm toolkit for Ada 95
--
-- Core toolkit - Ending component
--
-- Author  Matthew Caryl
-- Created 10.12.96
--

with Mutants.Core.Ending, Ada.Calendar;

package Mutants.Core.Ending.Time is

	type Time_Ending is new Ending with private;

	procedure Done(Ending : in out Time_Ending; Done : out Boolean);
	procedure Reset(Ending : in out Time_Ending; Period : in Duration);

private
	
	type Time_Ending is new Ending with
		record
			Finish_Time : Ada.Calendar.Time := Ada.Calendar.Clock;
		end record;
	
end Mutants.Core.Ending.Time;
