--
-- MUTANTS : A generic genetic algorithm toolkit for Ada 95
--
-- Core toolkit - Evaluation component
--
-- Author  Matthew Caryl
-- Created 12.12.96
--

with Ada.Finalization;
with Mutants.Core.Representation;
use Mutants.Core.Representation;

package Mutants.Core.Evaluation is

	type Evaluation is abstract new Ada.Finalization.Controlled with private;
	subtype Evaluation_Class is Evaluation'Class;

	function Evaluate(Evaluation : in Evaluation; Representation : in Representation_Access) return Float is abstract;

private

	type Evaluation is abstract new Ada.Finalization.Controlled with null record;

end Mutants.Core.Evaluation;
