--
-- MUTANTS : a generic genetic algorithm toolkit for Ada 95
--
-- Core Toolkit - Unity Fitness component
--
-- Author  Matthew Caryl
-- Created 18.12.96
--

with Mutants.Core.Population;
with Mutants.Core.Fitness;
with Mutants.Core.Individual;
use Mutants.Core.Population;
use Mutants.Core.Fitness;

package body Mutants.Core.Fitness.Unity is

	procedure Attach(Fit : in out Unity_Fitness; Pop : in Population_Access) is
	begin
		Fit.Source := Pop;
	end Attach;

	procedure Retrieve(Fit : in out Unity_Fitness; Individual : in Individual_Access; Value : out Float; Found : out Boolean) is
		it : PopulationIterator := Iterator(Fit.Source);
		more : Boolean;
		i : Individual_Access;
	begin
		Next(it, more, i);
		while more and then i /= Individual loop
			Next(it, more, i);
		end loop;
		if (i = Individual) then
			Value := Evaluation(i);
			Found := true;
		else
			Found := false;
		end if;
	end Retrieve;

	function Iterator(Fit : in Unity_Fitness) return FitnessIterator'Class is
		i : Unity_FitnessIterator;
	begin
		i.Source := Iterator(Fit.Source);
		return i;
	end Iterator;

	procedure Next(Iterator : in out Unity_FitnessIterator; More : out Boolean; Individual : out Individual_Access; Value : out Float) is
	begin
		Next(Iterator.Source, More, Individual);
		Value := Evaluation(Individual);
	end Next;

end Mutants.Core.Fitness.Unity;
