--
-- MUTANTS : a generic genetic algorithm toolkit for Ada 95
--
-- Core Toolkit - Unity Fitness component
--
-- Author  Matthew Caryl
-- Created 18.12.96
--

with Mutants.Core.Population;
with Mutants.Core.Fitness;
with Mutants.Core.Individual;
use Mutants.Core.Population;
use Mutants.Core.Fitness;

package Mutants.Core.Fitness.Unity is

	type Unity_Fitness is new Fitness with private;
	type Unity_FitnessIterator is new FitnessIterator with private;

	procedure Attach(Fit : in out Unity_Fitness; Pop : in Population_Access);
	procedure Retrieve(Fit : in out Unity_Fitness; Individual : in Individual_Access; Value : out Float; Found : out Boolean);
	function Iterator(Fit : in Unity_Fitness) return FitnessIterator'Class;
	procedure Next(Iterator : in out Unity_FitnessIterator; More : out Boolean; Individual : out Individual_Access; Value : out Float);

private

	type Unity_Fitness is new Fitness with
		record
			Source : Population_Access;
		end record;
	type Unity_Fitness_Access is access all Unity_Fitness;
	
	type Unity_FitnessIterator is new FitnessIterator with
		record
			Source : PopulationIterator;
		end record;

end Mutants.Core.Fitness.Unity;
