--
-- MUTANTS : a generic genetic algorithm toolkit for Ada 95
--
-- Core Toolkit - Fitness component
--
-- Author  Matthew Caryl
-- Created 16.12.96
--

with Mutants.Core.Population;
with Mutants.Core.Individual;
use Mutants.Core.Population;
use Mutants.Core.Individual;

package Mutants.Core.Fitness is

	type Fitness is abstract tagged private;
	type Fitness_Access is access all Fitness'Class;
	subtype Fitness_Class is Fitness'Class;
	type FitnessIterator is abstract tagged private;
	type FitnessIterator_Access is access all FitnessIterator'Class;
	
	procedure Attach(Fit : in out Fitness; Pop : in Population_Access) is abstract;
	procedure Retrieve(Fit : in out Fitness; Individual : in Individual_Access; Value : out Float; Found : out Boolean) is abstract;
	function Iterator(Fit : in Fitness) return FitnessIterator'Class is abstract;
	procedure Next(Iterator : in out FitnessIterator; More : out Boolean; Individual : out Individual_Access; Value : out Float) is abstract;

private

	type Fitness is abstract tagged null record;
	type FitnessIterator is abstract tagged null record;

end Mutants.Core.Fitness;
