--
-- MUTANTS : a generic genetic algorithm toolkit for Ada 95
--
-- Core Toolkit - Generational Model component
--
-- Author  Matthew Caryl
-- Created 14.12.96
--

with Mutants.Core.Model;
with Mutants.Core.Random;
with Mutants.Core.Ending;
with Mutants.Core.Population;
with Mutants.Core.Fitness;
with Mutants.Core.Creator;
with Mutants.Core.Selector;
with Mutants.Core.Individual;
use Mutants.Core.Model;
use Mutants.Core.Random;
use Mutants.Core.Ending;
use Mutants.Core.Population;
use Mutants.Core.Fitness;
use Mutants.Core.Creator;
use Mutants.Core.Selector;
use Mutants.Core.Individual;

with Ada.Text_IO;
use Ada.Text_IO;

package body Mutants.Core.Model.Generation is

	procedure Run(Modl : in out Generation_Model; Eval : in out Evaluation_Class; Fit : in out Fitness_Class; Sel : in out Selector_Class; Rep : in out Creator_Class; Ends : in out Ending_Class) is
		new_population : aliased Mutants.Core.Population.Population;
		d : Boolean;
		required : Boolean;
	begin
		Done(Ends, d);
		while not d loop
			EvaluatePopulation(Modl.Population, Eval);
			Attach(Fit, Modl.Population);
			Attach(Sel, Fit);
			Mutants.Core.Creator.Selector(Rep, Sel'Unchecked_Access, required);
			Create(Rep, new_population, Size(Modl.Population.all));
			Copy(Modl.Population.all, new_population);
			Clear(new_population);
			Done(Ends, d);
		end loop;
	end Run;

end Mutants.Core.Model.Generation;
