--
-- MUTANTS : a generic genetic algorithm toolkit for Ada 95
--
-- Core Toolkit - Model component
--
-- Author  Matthew Caryl
-- Created 14.12.96
--

with Mutants.Core.Population;
with Mutants.Core.Individual;
with Mutants.Core.Creator;
use Mutants.Core.Population;
use Mutants.Core.Individual;
use Mutants.Core.Creator;

package body Mutants.Core.Model is
	
	procedure Initialize(Model : in out Model) is
	begin
		Model.Population := new Mutants.Core.Population.Population;
		Create(Model.Initialise_Creator.all, Model.Population.all, Model.Population_Size);
	end Initialize;
	
	procedure Get_Population(Model : Model; Population : out Population_Access) is
	begin
		Population := Model.Population;
	end Get_Population;

	procedure EvaluatePopulation(Pop : in Population_Access; Eval : Evaluation_Class) is
		m : Boolean;
		iter : PopulationIterator;
		i : Individual_Access;
	begin
		iter := Iterator(Pop);
		Next(iter, m, i);
		while m loop
			Mutants.Core.Individual.Evaluation(i, Evaluate(Eval, Mutants.Core.Individual.Representation(i)));
			Next(iter, m, i);
		end loop;
	end EvaluatePopulation;

end Mutants.Core.Model;
