--
-- MUTANTS : a generic genetic algorithm toolkit for Ada 95
--
-- Core Toolkit - Model component
--
-- Author  Matthew Caryl
-- Created 14.12.96
--
-- Unfinished - need to include history varient

with Mutants.Core.Ending;
with Mutants.Core.Population;
with Mutants.Core.Fitness;
with Mutants.Core.Creator;
with Mutants.Core.Selector;
with Mutants.Core.Evaluation;
with Ada.Finalization;
use Mutants.Core.Ending;
use Mutants.Core.Population;
use Mutants.Core.Fitness;
use Mutants.Core.Creator;
use Mutants.Core.Selector;
use Mutants.Core.Evaluation;

package Mutants.Core.Model is

	type Model(Initialiser: Creator_Access; Size : Natural) is abstract new Ada.Finalization.Controlled with private;
	subtype Model_Class is Model'Class;
	type Model_Access is access all Model_Class;
	
       procedure Run(Modl : in out Model; Eval : in out Evaluation_Class; Fit : in out Fitness_Class; Sel : in out Selector_Class; Rep : in out Creator_Class; Ends : in out Ending_Class) is abstract;
	
	procedure Get_Population(Model : Model; Population : out Population_Access);
	procedure EvaluatePopulation(Pop : in Population_Access; Eval : Evaluation_Class);

private

	type Model(Initialiser: Creator_Access; Size : Natural) is abstract new Ada.Finalization.Controlled with
		record
			Initialise_Creator : Creator_Access := Initialiser;
			Population_Size : Natural := Size;
			Population : Population_Access;
		end record;

	procedure Initialize(Model : in out Model);

end Mutants.Core.Model;
