--
-- MUTANTS : A generic genetic algorithm toolkit for Ada 95
--
-- Core toolkit - Bit Representation component
--
-- Author  Matthew Caryl
-- Created 11.12.96
--

with Mutants.Core.Representation;

package Mutants.Core.Representation.Bit is

	type Bit_Representation is new Representation with private;
	
	function Equal(one, two : Bit_Representation) return Boolean;

	function Get(Representation : in Bit_Representation) return Boolean;
	procedure Set(Representation : out Bit_Representation; Bit : Boolean);

	type Bit_Representation_Access is access all Bit_Representation;

	function Get(Representation : in Bit_Representation_Access) return Boolean;
	procedure Set(Representation : in Bit_Representation_Access; Bit : Boolean);

private

	type Bit_Representation is new Representation with
		record
			Representation : Boolean := false;
		end record;

end Mutants.Core.Representation.Bit;
