--
-- MUTANTS : A generic genetic algorithm toolkit for Ada 95
--
-- Core toolkit - Integer Representation component
--
-- Author  Matthew Caryl
-- Created 4.2.97
--

with Mutants.Core.Representation;

package Mutants.Core.Representation.Integer is

	type Integer_Representation is new Mutants.Core.Representation.Representation with private;

 	function Equal(one, two : Integer_Representation) return Boolean;

	function Get(Rep : Integer_Representation) return Standard.Integer;
	procedure Set(Rep : out Integer_Representation; Int : Standard.Integer);

	type Integer_Representation_Access is access all Integer_Representation;

	function Get(Rep : in Integer_Representation_Access) return Standard.Integer;
	procedure Set(Rep : in Integer_Representation_Access; Int : Standard.Integer);

private

	type Integer_Representation is new Mutants.Core.Representation.Representation with
		record
			Rep : Standard.Integer := 0;
		end record;

end Mutants.Core.Representation.Integer;
