--
-- MUTANTS : a generic genetic algorithm toolkit for Ada 95
--
-- Core Toolkit - AntiRoulette Wheel Selector component
--
-- Author  Matthew Caryl
-- Created 1.2.97
--

with Mutants.Core.Selector;
with Mutants.Core.Individual;
with Mutants.Core.Random;
use Mutants.Core.Selector;
use Mutants.Core.Individual;
use Mutants.Core.Random;

package Mutants.Core.Selector.AntiRoulette is

        type AntiRoulette_Selector(Random : Random_Access) is new Selector with private;

        procedure Attach(Sel : in out AntiRoulette_Selector; Fit : in out Mutants.Core.Fitness.Fitness'Class);
        procedure Get(Sel : in out AntiRoulette_Selector; Individual : out Individual_Access);
        procedure Put(Sel : in out AntiRoulette_Selector; Individual : in Individual_Access);

private

        type AntiRoulette_Selector(Random : Random_Access) is new Selector with
		record
			Fitness : Fitness_Access;
			Total : Float;
			Max_Min : Float;
			Chance : Random_Access := Random;
		end record;

end Mutants.Core.Selector.AntiRoulette;
