--
-- MUTANTS : a generic genetic algorithm toolkit for Ada 95
--
-- Core Toolkit - Cyclic Selector component
--
-- Author  Matthew Caryl
-- Created 11.2.97
--

with Mutants.Core.Selector;
with Mutants.Core.Individual;
with Mutants.Core.Fitness;
use Mutants.Core.Selector;
use Mutants.Core.Individual;
use Mutants.Core.Fitness;

package body Mutants.Core.Selector.Cyclic is

        procedure Attach(Sel : in out Cyclic_Selector; Fit : in out Mutants.Core.Fitness.Fitness'Class) is
	begin
		Sel.It := new FitnessIterator'Class'(Iterator(Fit));
	end Attach;

        procedure Get(Sel : in out Cyclic_Selector; Individual : out Individual_Access) is
		m : Boolean;
		v : Float;
	begin
		Next(Sel.It.all, m, Individual, v);
		if not m then
			Sel.It := new FitnessIterator'Class'(Iterator(Sel.Fit.all));
			Next(Sel.It.all, m, Individual, v);
		end if;
	end Get;

        procedure Put(Sel : in out Cyclic_Selector; Individual : in Individual_Access) is
	begin
		null;
	end Put;

end Mutants.Core.Selector.Cyclic;
