--
-- MUTANTS : a generic genetic algorithm toolkit for Ada 95
--
-- Core Toolkit - Cyclic Selector component
--
-- Author  Matthew Caryl
-- Created 11.2.97
--

with Mutants.Core.Selector;
with Mutants.Core.Individual;
with Mutants.Core.Fitness;
use Mutants.Core.Selector;
use Mutants.Core.Individual;
use Mutants.Core.Fitness;

package Mutants.Core.Selector.Cyclic is

        type Cyclic_Selector(Size : Natural) is new Selector with private;

        procedure Attach(Sel : in out Cyclic_Selector; Fit : in out Mutants.Core.Fitness.Fitness'Class);
        procedure Get(Sel : in out Cyclic_Selector; Individual : out Individual_Access);
        procedure Put(Sel : in out Cyclic_Selector; Individual : in Individual_Access);

private

        type Cyclic_Selector(Size : Natural) is new Selector with
		record
			Fit : Fitness_Access := null;
			It : FitnessIterator_Access := null;
			Cycle : Natural := Size;
		end record;

end Mutants.Core.Selector.Cyclic;
