--
-- MUTANTS : a generic genetic algorithm toolkit for Ada 95
--
-- Core Toolkit - High Selector component
--
-- Author  Matthew Caryl
-- Created 19.12.96
--

with Mutants.Core.Selector;
with Mutants.Core.Individual;
use Mutants.Core.Selector;
use Mutants.Core.Individual;

package body Mutants.Core.Selector.High is

        procedure Attach(Sel : in out High_Selector; Fit : in out Mutants.Core.Fitness.Fitness'Class) is
		fi : FitnessIterator'Class := Iterator(Fit);
		more : Boolean;
		i : Individual_Access;
		v : Float;
		high_i : Individual_Access;
		high_v : Float;
	begin
		Next(fi, more, high_i, high_v);
		if not more then
			raise Empty_Population_Exception;
		end if;
		while more loop
			Next(fi, more, i, v);
			if v > high_v then
				high_v := v;
				high_i := i;
			end if;
		end loop;
		Sel.High_Individual := high_i;
	end Attach;

        procedure Get(Sel : in out High_Selector; Individual : out Individual_Access) is
	begin
		Individual := Sel.High_Individual;
	end Get;

        procedure Put(Sel : in out High_Selector; Individual : in Individual_Access) is
	begin
		null;
	end Put;

end Mutants.Core.Selector.High;
