--
-- MUTANTS : A generic genetic algorithm toolkit for Ada 95
--
-- Extended toolkit - Order crossover reproduction component
--
-- Author  Matthew Caryl
-- Created 7.2.97
--
-- Unfinished - need to include history varient

with Mutants.Core.Selector;
with Mutants.Core.Population;
with Mutants.Core.Representation.Order;
with Mutants.Core.Random;
with Mutants.Core.Individual;
with Ada.Unchecked_Deallocation;
use Mutants.Core.Selector;
use Mutants.Core.Population;
use Mutants.Core.Representation;
use Mutants.Core.Random;
use Mutants.Core.Individual;

package body Mutants.Extended.Creator.Order_Crossover_Reproduction is

	use Order_Package;
	procedure Free is new Ada.Unchecked_Deallocation(Order_Representation, Order_Representation_Access);

	use Order_Package;
	function Search(Source : in Order_Representation_Access; Start, Finish : in Natural; Value : in Element_Type_Access) return Boolean is
		p, q : Natural;
		e : Element_Type_Access;
	begin
		p := Start;
		q := Finish;
		while p /= q loop
			Get(Source, p, e);
			if Order_Package.Equal(e.all, Value.all) then
				q := p;
			else
				p := p + 1;
			end if;
		end loop;
		return Order_Package.Equal(e.all, Value.all);
	end Search;

	use Order_Package;
	procedure Create(Creator : in out Order_Crossover_Reproduction; Pop : in out Mutants.Core.Population.Population; Size : in Natural) is
		i : Individual_Access;
		p1, p2 : Order_Representation_Access;
		e : Element_Type_Access;
		o : Order_Representation_Access;
		k1, k2 : Natural;
		p, q, r : Natural;
		s : Natural;
	begin
		for k in 1..Size loop
			-- select two parents
			Get(Creator.Selector.all, i);
			p1 := Order_Representation_Access(Mutants.Core.Individual.Representation(i));
			Get(Creator.Selector.all, i);
			p2 := Order_Representation_Access(Mutants.Core.Individual.Representation(i));
			-- choose split
			s := Order_Package.Size(p1);
			k1 := Value(Creator.Chance, Integer(s / 2)) + 1;
			k2 := Value(Creator.Chance, s - Integer(s / 2)) + 1 + k1;
			-- construct representation
			o := new Order_Representation(s);
			-- copy from 1st or 2nd paranet depending on whether value is in selected
			r := k1;
			for j in 1..s loop
				Get(p2, j, e);
				if Search(p1, k1, k2, e) then
					Get(p1, r, e);
					Set(o, j, e.all);
					r := r + 1;
				else
					Set(o, j, e.all);
				end if;
			end loop;
			-- construct individual
			i := new Mutants.Core.Individual.Individual(Representation_Access(o));
			Add(Pop, i);
			Free(o);
		end loop;
	end Create;

	procedure Selector(Creator : in out Order_Crossover_Reproduction; Sel : Selector_Access; Required : out Boolean) is
	begin
		Creator.Selector := Sel;
		Required := true;
	end Selector;

	function Parents(Creator : in Order_Crossover_Reproduction) return Natural is
	begin
		return 2;
	end Parents;

	use Order_Package;
	procedure Breed(Creator : in out Order_Crossover_Reproduction; Reps_In : in Representation_Access_Array; Rep_Out : out Representation_Access; Success : out Boolean) is
		o : Order_Representation_Access;
		p1, p2 : Order_Representation_Access;
		e : Element_Type_Access;
		s : Natural;
		k1, k2 : Natural;
		r : Natural;
	begin
		-- select two parents
		p1 := Order_Representation_Access(Reps_In(1));
		p2 := Order_Representation_Access(Reps_In(2));
		-- choose split
		s := Order_Package.Size(p1);
		k1 := Value(Creator.Chance, Integer(s / 2)) + 1;
		k2 := Value(Creator.Chance, s - Integer(s / 2)) + 1 + k1;
		-- construct representation
		o := new Order_Representation(s);
		-- copy from 1st or 2nd paranet depending on whether value is in selected
		r := k1;
		for j in 1..s loop
			Get(p2, j, e);
			if Search(p1, k1, k2, e) then
				Get(p1, r, e);
				Set(o, j, e.all);
				r := r + 1;
			else
				Set(o, j, e.all);
			end if;
		end loop;
		Rep_Out := Representation_Access(o);
		Success := true;
	end Breed;

end Mutants.Extended.Creator.Order_Crossover_Reproduction;
