--
-- MUTANTS : a generic genetic algorithm toolkit for Ada 95
--
-- Extended Toolkit - Order mutation reproduction component
--
-- Author  Matthew Caryl
-- Created 22.1.97
--
-- Unfinished - need to include history component

with Mutants.Core.Selector;
with Mutants.Core.Population;
with Mutants.Core.Representation.Order;
with Mutants.Core.Random;
with Mutants.Core.Individual;
with Ada.Unchecked_Deallocation;
use Mutants.Core.Selector;
use Mutants.Core.Population;
use Mutants.Core.Representation;
use Mutants.Core.Individual;
use Mutants.Core.Random;

package body Mutants.Extended.Creator.Order_Mutation_Reproduction is
	
	use Order_Package;
	procedure Free is new Ada.Unchecked_Deallocation(Order_Representation, Order_Representation_Access);
	
	use Order_Package;
	procedure Create(Creator : in out Order_Mutation_Reproduction; Pop : in out Mutants.Core.Population.Population; Size : in Natural) is
		i : Individual_Access;
		e : Element_Type_Access;
		o : Order_Representation_Access;
		op : Order_Representation_Access;
		m1, m2 : Natural;
		s : Natural;
		success : Boolean;
	begin
		-- make required number of individuals
		for j in 1..Size loop
			-- select paraent
			Get(Creator.Selector.all, i);
			op := Order_Representation_Access(Mutants.Core.Individual.Representation(i));
			s := Order_Package.Size(op);
			-- construct representation
			o := new Order_Representation(s);
			m1 := Value(Creator.Chance, s - 1) + 1;
			m2 := Value(Creator.Chance, s - m1) + m1 + 1;
			-- copy positions before m1
			for i in 1..(m1 - 1) loop
				Get(op, i, e);
				Set(o, i, e.all);
			end loop;
			-- place contendts of m2 before m1
			Get(op, m2, e);
			Set(o, m1, e.all);
			Get(op, m1, e);
			Set(o, m1 + 1, e.all);
			-- copy positions between m1 and m2
			for i in (m1 + 1)..(m2 - 1) loop
				Get(op, i, e);
				Set(o, i + 1, e.all);
			end loop;
			-- copy positions after m2
			for i in (m2 + 1)..s loop
				Get(op, i, e);
				Set(o, i, e.all);
			end loop;
			-- construct individual
			i := new Mutants.Core.Individual.Individual(Representation_Access(o));
			Add(Pop, i);
			Free(o);
		end loop;
	end Create;

	procedure Selector(Creator : in out Order_Mutation_Reproduction; Sel : Selector_Access; Required : out Boolean) is
	begin
		Creator.Selector := Sel;
		Required := true;
	end Selector;
	
	function Parents(Creator : in Order_Mutation_Reproduction) return Natural is
	begin
		return 1;
	end Parents;

	use Order_Package;
	procedure Breed(Creator : in out Order_Mutation_Reproduction; Reps_In : in Representation_Access_Array; Rep_Out : out Representation_Access; Success : out Boolean) is
		o : Order_Representation_Access;
		op : Order_Representation_Access;
		s : Natural;
		e : Element_Type_Access;
		m1, m2 : Natural;
	begin
		op := Order_Representation_Access(Reps_In(1));
		s := Size(op);
		-- construct representation
		o := new Order_Representation(s);
		m1 := Value(Creator.Chance, s - 1) + 1;
		m2 := Value(Creator.Chance, s - m1) + m1 + 1;
		-- copy positions before m1
		for i in 1..(m1 - 1) loop
			Get(op, i, e);
			Set(o, i, e.all);
		end loop;
		-- place contendts of m2 before m1
		Get(op, m2, e);
		Set(o, m1, e.all);
		Get(op, m1, e);
		Set(o, m1 + 1, e.all);
		-- copy positions between m1 and m2
		for i in (m1 + 1)..(m2 - 1) loop
			Get(op, i, e);
			Set(o, i + 1, e.all);
		end loop;
		-- copy positions after m2
		for i in (m2 + 1)..s loop
			Get(op, i, e);
			Set(o, i, e.all);
		end loop;
		Rep_Out := Representation_Access(o);
	end Breed;

end Mutants.Extended.Creator.Order_Mutation_Reproduction;
