--
-- MUTANTS : a generic genetic algorithm toolkit for Ada 95
--
-- Extended Toolkit - Order random reproduction component
--
-- Author  Matthew Caryl
-- Created 12.2.97
--
-- Unfinished - need to include history varient

with Mutants.Core.Selector;
with Mutants.Core.Population;
with Mutants.Core.Random;
with Ada.Unchecked_Deallocation;
use Mutants.Core.Individual;
use Mutants.Core.Population;
use Mutants.Core.Random;

package body Mutants.Extended.Creator.Order_Random_Reproduction is
	
	use Order_Package;
	procedure Free is new Ada.Unchecked_Deallocation(Order_Representation, Order_Representation_Access);

	use Order_Package;
	procedure Create(Creator : in out Order_Random_Reproduction; Pop : in out Mutants.Core.Population.Population; Size : in Natural) is
		i : Individual_Access;
		o : Order_Representation_Access;
		e : Element_Type_Access;
		e2 : Element_Type;
		s : Natural;
		op : Order_Representation_Access;
		p : Natural;
	begin
		-- create population
		for j in 1..Size loop
			Get(Creator.Selector.all, i);
			op := Order_Representation_Access(Mutants.Core.Individual.Representation(i));
			s := Order_Package.Size(op);
			o := new Order_Representation(s);
			-- copy parent
			for k in 1..s loop
				Get(op, k, e);
				Set(o, k, e.all);
			end loop;
			-- randomise order
			for k in 1..s loop
				p := Value(Creator.Chance, s) + 1;
				e2 := Get(o, k);
				Get(o, p, e);
				Set(o, k, e.all);
				Set(o, p, e2);
			end loop;
			-- create individual
			i := new Mutants.Core.Individual.Individual(Representation_Access(o));
			-- add to population
			Add(Pop, i);
			Free(o);
		end loop;
	end Create;

	procedure Selector(Creator : in out Order_Random_Reproduction; Sel : Selector_Access; Required : out Boolean) is
	begin
		Creator.Selector := Sel;
		Required := true;
	end Selector;

	function Parents(Creator : in Order_Random_Reproduction) return Natural is
	begin
		return 1;
	end Parents;
	
	use Order_Package;
        procedure Breed(Creator : in out Order_Random_Reproduction; Reps_In : in Representation_Access_Array; Rep_Out : out Representation_Access; Success : out Boolean) is
		s : Integer := Size(Order_Representation_Access(Reps_In(1)));
		o : Order_Representation_Access;
		op : Order_Representation_Access;
		e : Element_Type_Access;
		e2 : Element_Type;
		p : Natural;
	begin
		o := new Order_Representation(s);
		-- copy parent
		for k in 1..s loop
			Get(op, k, e);
			Set(o, k, e.all);
		end loop;
		-- randomise order
		for k in 1..s loop
			p := Value(Creator.Chance, s) + 1;
			e2 := Get(o, k);
			Get(o, p, e);
			Set(o, k, e.all);
			Set(o, p, e2);
		end loop;
		Rep_Out := Representation_Access(op);
	end Breed;
	
end Mutants.Extended.Creator.Order_Random_Reproduction;
