--
-- MUTANTS : a generic genetic algorithm toolkit for Ada 95
--
-- Population component test
--
-- Author  Matthew Caryl
-- Created 18.12.96
--

with Mutants.Core.Individual;
with Mutants.Core.Representation.Bit;
with Mutants.Core.Representation;
with Mutants.Core.Population;
with Ada.Text_IO.Enumeration_IO;
with Ada.Text_IO.Float_IO;
use Mutants.Core.Individual;
use Mutants.Core.Representation.Bit;
use Mutants.Core.Representation;
use Mutants.Core.Population;
use Ada.Text_IO;

procedure PopulationTest is

	package Boolean_IO is new Ada.Text_IO.Enumeration_IO(Boolean);
	package Float_IO is new Ada.Text_IO.Float_IO(Float);

	b : Bit_Representation_Access;
	i : Individual_Access;
	p : aliased Population;
	pi : PopulationIterator := Iterator(p'Unchecked_Access);
	m : boolean;
begin
	for n in 1..10 loop
		b := new Bit_Representation;
		if (n mod 2 = 0) then
			Set(b, true);
		else
			Set(b, false);
		end if;
		i := new Individual(Representation_Access(b));
		Evaluation(i, Float(n));
		Add(p, i);
	end loop;
	Next(pi, m, i);
	while m loop
		Boolean_IO.Put(Get(Bit_Representation_Access(Mutants.Core.Individual.Representation(i))));
		New_Line;
		Float_IO.Put(Evaluation(i));
		New_Line;
		Next(pi, m, i);
	end loop;
end PopulationTest;
