--
-- MUTANTS : A generic genetic algorithm toolkit for Ada 95
--
-- Test harness for Random
--
-- Author  Matthew Caryl
-- Created 4.12.96
--

with Ada.Text_IO;
with Ada.Text_IO.Enumeration_IO;
with Ada.Text_IO.Integer_IO;
with Ada.Text_IO.Float_IO;
with Mutants.Core.Random;
use Ada.Text_IO;
use Mutants.Core.Random;

procedure RandomTest is
	package Boolean_IO is new Ada.Text_IO.Enumeration_IO(Boolean);
	package Integer_IO is new Ada.Text_IO.Integer_IO(Integer);
	package Float_IO is new Ada.Text_IO.Float_IO(Float);

	r1 : Mutants.Core.Random.Random_Access := new Mutants.Core.Random.Random;
	r2 : Mutants.Core.Random.Random_Access := new Mutants.Core.Random.Random(2);
	r3 : Mutants.Core.Random.Random_Access := new Mutants.Core.Random.Random(2);

begin
	Put_Line("first test");
	for i in 1..5 loop
		Boolean_IO.Put(Value(r1));
		New_Line;
	end loop;
	Put_Line("second test");
	for i in 1..5 loop
		Boolean_IO.Put(Value(r2));
		New_Line;
	end loop;
	Put_Line("third test");
	r2.all := r3.all;
	for i in 1..5 loop
		Boolean_IO.Put(Value(r2));
		New_Line;
	end loop;
	Put_Line("fourth test");
	Reset(r2.all, 1);
	for i in 1..5 loop
		Boolean_IO.Put(Value(r2));
		New_Line;
	end loop;
	Put_Line("fifth test");
	for i in 1..5 loop
		Integer_IO.Put(Value(r1, 100));
		New_Line;
	end loop;
	Put_Line("sixth test");
	for i in 1..5 loop
		Integer_IO.Put(Value(r1, 100, 201));
		New_Line;
	end loop;
	Put_Line("seventh test");
	for i in 1..5 loop
		Float_IO.Put(Value(r1, 100, 10));
		New_Line;
	end loop;
	Put_Line("eighth test");
	for i in 1..5 loop
		Float_IO.Put(Value(r1, 100, 201, 10));
		New_Line;
	end loop;
end;
